#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

if ($q->param('fct') eq "retrieve") {&retrieve_emails; exit;}

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}


##################################################################################

sub retrieve_emails
{

print "Content-type: text/plain\n\n";

$timep = time();

if ($q->param('link_type') eq "expired")
	{
	$retrieve_info = "Retrieving Email Addresses of Expired Premium Links...";
	$where_sql = "AND ((B.subs_expire < '$timep') AND (B.subs_expire > '0'))";
	}

if ($q->param('link_type') eq "nonexpired")
	{
	$retrieve_info = "Retrieving Email Addresses of Premium Links That Has Not Expired...";
	#$where_sql = "AND ((B.subs_expire > '$timep') or (B.subs_expire = ''))";
	$where_sql = "AND (B.premium > 0)";
	}

if ($q->param('link_type') eq "no_exp")
	{
	$retrieve_info = "Retrieving Email Addresses of Premium Links That Has No Expiry Date...";
	$where_sql = "AND (B.subs_expire = '') AND (B.premium > 0)";
	}

if ($q->param('link_type') eq "all")
	{
	$retrieve_info = "Retrieving All Premium Link Email Addesses...";
	$where_sql = "AND ((B.subs_expire > 0) OR (B.premium > 0))";
	}


#####

if ($q->param('seperator') eq "")
	{
	$seperator = ";";
	}
	else
	{
	$seperator = $q->param('seperator');
	}

	if ($q->param('R1') eq "email")
		{
		$group = "group by B.email";
		}
	elsif ($q->param('R1') eq "title")
		{
		$group = "group by B.title";
		}

$sql = "SELECT A.l1,A.l2,A.l3,A.l4,A.l5,A.l6,A.l7,A.l8,A.l9,A.l10,A.l11,A.l12,A.l13,A.l14,A.l15,A.l16, B.* 
					FROM dirs AS A, links as B
					WHERE (A.cid = B.cid) $where_sql AND (B.email != '')
					$group";


#########

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
#print "==> $sql \n\n";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

$rows = $sth->rows();

if ($rows > 0)
	{

print "====================================================================\n";
print "$retrieve_info\n";
print "====================================================================\n";
print "The retrieval is in the following format:\n";

$retriva = "Email" . $seperator;

if ($q->param('title') ne "") { $retriva = $retriva . "Title" . $seperator; }
if ($q->param('description') ne "") { $retriva = $retriva . "Description" . $seperator; }
if ($q->param('keywords') ne "") { $retriva = $retriva . "Keywords" . $seperator; }
if ($q->param('url') ne "") { $retriva = $retriva . "URL" . $seperator; }
if ($q->param('name') ne "") { $retriva = $retriva . "Name" . $seperator; }
if ($q->param('rating') ne "") { $retriva = $retriva . "Rating" . $seperator; }
if ($q->param('votes') ne "") { $retriva = $retriva . "Votes" . $seperator; }
if ($q->param('lnkpassword') ne "") { $retriva = $retriva . "Link Password" . $seperator; }
if ($q->param('lnkpassword_url') ne "") { $retriva = $retriva . "Modify URL" . $seperator; }
if ($q->param('rating_link') ne "") { $retriva = $retriva . "Rating URL" . $seperator; }
if ($q->param('subs_expire') ne "") { $retriva = $retriva . "Premium Expiry Date" . $seperator; }
if ($q->param('cat') ne "") { $retriva = $retriva . "Category" . $seperator; }

print $retriva . "\n\n";
	
	}
	else
	{
	
	print "No Matches Found.";
	
	}



while ( @row = $sth->fetchrow() )
	{
	$cats	= "";
	for ($ms1 = 0; $ms1 < 16; $ms1++) 
		{
		if ($row[$ms1] ne "")
			{
			$cats = $cats . $row[$ms1] . "/";
			}
		}

	#######
	$erow = "";
	
	$erow = $erow . $row[25] . $seperator;
	
	$title = $row[18];
	if ($q->param('title') ne "") { $erow = $erow . $title . $seperator; }
	
	$description = $row[19]; $description =~ s/\n//g;
	if ($q->param('description') ne "") { $erow = $erow . $description . $seperator; }
	
	$keywords = $row[20];
	if ($q->param('keywords') ne "") { $erow = $erow . $keywords . $seperator; }
	
	$url = $row[21];
	if ($q->param('url') ne "") { $erow = $erow . $url . $seperator; }
	
	$name = $row[24];
	if ($q->param('name') ne "") { $erow = $erow . $name . $seperator; }
	
	$rating = $row[26];
	if ($rating = "") { $rating = 0; }
	if ($q->param('rating') ne "") { $erow = $erow . $rating . $seperator; }
	
	$votes = $row[27];
	if ($votes = "") { $votes = 0; }
	if ($q->param('votes') ne "") { $erow = $erow . $votes . $seperator; }

	$modify_password = $row[38];
	if ($q->param('lnkpassword') ne ""){$erow = $erow . $modify_password . $seperator;}
	
	$modify_link = "$script_url/tmodify.cgi?id=$row[16]&cid=$row[17]"; 
	if ($q->param('lnkpassword_url') ne ""){$erow = $erow . $modify_link . $seperator;}
	
	$rating_code_link = "$script_url/gethtml.cgi?id=$row[16]-$row[17]";
	if ($q->param('rating_link') ne ""){$erow = $erow . $rating_code_link . $seperator;}
	
	$expdate = "";
	if ($row[37] > 0)
			{
			$expdate = acs::decode_date($row[37]);
			($expdate, $tmp) = split (/-/, $expdate);
			}
			else 
			{
			$expdate = "Never Expires"; 
			}
	$link_expiry_date = $expdate;
	
	if ($q->param('subs_expire') ne ""){$erow = $erow . $link_expiry_date . $seperator;}
	
	$category = $cats;
	if ($q->param('cat') ne ""){$erow = $erow . $category . $seperator;}
	
	$erow = substr($erow, 0, length($erow) - 1);
	print $erow . "\n";
	}


$sth->finish;
$dbh->disconnect;

}






sub start
{


$hbox = acs::get_heading_box("$web_url/ic_email4.gif", "Retrieve Email Addresses of Premium Link Onwers", qq[
Enables you to retrieve email addresses of premium links and of those that have
expired. <br>
<strong><a href="$admin_url/admin33.cgi"
onclick="popup('$admin_url/admin33.cgi',750,600);return false;">Email Mailing &amp;
Address Retrieval </a>&gt;&gt; Retrieve Email Addresses of Premium Link Owners </strong>
]);



print <<END_OF_EM;

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />   
</head>

<body>

$hbox



<form method="POST" action="$admin_url/admin25.cgi">
  <input type="hidden" name="fct" value="retrieve"><table border="0" cellpadding="6"
  cellspacing="1" width="100%" style="border: 1px solid rgb(219,219,219)">
    <tr>
      <td width="96%" colspan="2" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Retrieve
      Email Addresses of Premium or Expired Premium Links: </strong></td>
    </tr>
    <tr>
      <td width="12%" class="normaltext"><strong>Link Type: </strong></td>
      <td width="84%" class="normaltext"><select name="link_type" size="1">
        <option value="expired"> Only Retrieve Email Addresses of Expired Premium Links </option>
        <option value="nonexpired"> Only Retrieve Email Addresses of Premium Links Which Has Not Expired </option>
        <option value="no_exp"> Only Retrieve Email Addresses of Premium Links Which Has No Expiry Date </option>
        <option value="all"> Retrieve All Email Addresses of All Premium Links </option>
      </select> </td>
    </tr>
    <tr>
      <td width="96%" colspan="2" class="normaltext"><strong>Fields To Include With Email Retrieval: <br>
      </strong>This option enables you to include some more information (like names, link
      titles, descriptions, passwords, etc.) when retrieving the email addresses. This can be
      handy if you would like to include names, link titles, descriptions, etc.. in the emails
      you send to users. </td>
    </tr>
    <tr>
      <td width="96%" colspan="2" class="normaltext"><input type="checkbox" name="title" value="Y"> Title <br>
      <input type="checkbox" name="description" value="Y"> Description <br>
      <input type="checkbox" name="keywords" value="Y"> Keywords <br>
      <input type="checkbox" name="url" value="Y"> Url <br>
      <input type="checkbox" name="name" value="Y"> Name <br>
      <input type="checkbox" name="rating" value="Y"> Rating <br>
      <input type="checkbox" name="votes" value="Y"> Votes <br>
      <input type="checkbox" name="lnkpassword" value="Y"> Modify Password <br>
      <input type="checkbox" name="lnkpassword_url" value="Y"> Link to Modify Page <br>
      <input type="checkbox" name="rating_link" value="Y"> Link where link owners can get the
      rating code to put on their web pages <br>
      <input type="checkbox" name="subs_expire" value="Y"> Premium Link Expiry Date <br>
      <input type="checkbox" name="cat" value="Y"> Category <br>
      &nbsp;&nbsp; <br>
      <strong>By what character would you like the fields to be separated: </strong><input
      type="text" name="seperator" size="3"> (Default is a semi-colon) <p><input type="radio"
      value="email" checked name="R1"> Prevent duplicates on e-mails <br>
      <input type="radio" name="R1" value="title"> Prevent duplicates on titles <br>
      </p>
      <p><input type="submit" value="Retrieve Email Addresses" name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>




</body>
</html>


END_OF_EM

}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


